function thissoft = ZCNET_convert_phase_cost_to_prob(thisraw)
    thisbitnum = log2(length(thisraw));
    [thisminval, thisminidx] = min(thisraw);
    thissoft = zeros(1,thisbitnum);
    guessbitvals = dec2bin(thisminidx-1+power(2,thisbitnum))-'0'; guessbitvals=guessbitvals(2:end); % NOTE: MSB smaller index
    for lh2=1:thisbitnum  
        thisplugin = guessbitvals; thisplugin(lh2) = 1-thisplugin(lh2);
        thisflipidx = sum(power(2,[length(thisplugin)-1:-1:0]).*thisplugin)+1;
        thiscost = thisraw(thisflipidx);
        thisabsdelta = (thiscost - thisminval)/thisminval;
        thisA = sqrt(1/(1+thisabsdelta));
        thisy = (1-thisA)/(1+thisA);
        thissoft(lh2) = sign(guessbitvals(lh2)-0.5)*thisy;
    end
end
